mod Ex06c

incl Mtex

incl Mtexln

incl Mtexset

incl Maux

loc rem 
  \para \bf  6. CVIČENIE Z PREDMETU 1-INF-465 DEKLARATÍVNE PROGRAMOVANIE  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Dátum:  \end piatok 1.4.2011 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-INF-465-dp/1011ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Úvodná poznámka.  \end Toto cvičenie je venované zoznamom. 
  Zadanie sa skladá z týchto súborov: 
  \items 
   \item \para Súbory \it  mtex*.cl  \end obsahujú makrá pre CL-TeX. 
   \item \para Súbory \it  maux*.cl  \end obsahujú definície niektorých 
         funkcií a predikátov. 
   \item \para Súbory \it  ex*.cl  \end obsahujú úlohy, ktoré máte riešiť 
         na tomto cvičení. 
   \item \para Súbor \it  msyntax.cl  \end obsahuje základnú syntax systému 
         CL. 
  \end
  \para Tieto súbory sa musia skompilovať v správnom poradí. Presný postup 
  je uvedený v súbore \it  readme.txt  \end. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
   \item \para \it  [2]  \end J. Kľuka. Lecture Notes from Introduction to 
         Declarative Programming Summer 2010/11. 
  \end

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  [CL] Remark.  \end The module \it  Msyntax  \end in the file \it  
  msyntax.cl  \end contains the syntax of the system CL. 

rem 
  \para \bf  Chapter. Programs Operating on Lists.  \end 

rem 
  \para \bf  Section. Applications of Lists.  \end 

rem 
  \para \bf  Subsection. Finite Sets.  \end 

rem 
  \para \bf  Finite sets.  \end 

pred Set 
  Set(s) <-> \a i\a j(i < j & j < L(s) -> Sub(s,i) < Sub(s,j))

rem 
  \para \bf  Set membership.  \end 
  \header* pred/2 Member 'Tex_p2_set_member' \end Define the predicate 
  \ft Member(a,s) \end such that 
  \eq* 
    Set(s) -> Member(a,s) <-> a in s
  \end

pred/2 Member 'Tex_p2_set_member'
  Member(a,s) <-> Poo

rem 
  \para \bf  Insertion.  \end \header* fun/2 Insert 'Tex_f2_set_insert' \end 
  Define the function \ft Insert(s,a) \end such that 
  \eq* 
    Set(s) -> b in Insert(s,a) <-> b = a \/ b in s
  \end
  \eq* 
    Set(s) -> Set Insert(s,a)
  \end

fun/2 Insert 'Tex_f2_set_insert'
  Insert(s,a) = Foo

rem 
  \para \bf  Deletion.  \end \header* fun/2 Delete 'Tex_f2_set_delete' \end 
  Define the function \ft Delete(s,a) \end such that 
  \eq* 
    Set(s) -> b in Delete(s,a) <-> b in s & b != a
  \end
  \eq* 
    Set(s) -> Set Delete(s,a)
  \end

fun/2 Delete 'Tex_f2_set_delete'
  Delete(s,a) = Foo

rem 
  \para \bf  Union.  \end \header* fun/2 Union 'Tex_f2_set_union' \end Define 
  the function \ft Union(s1,s2) \end such that 
  \eq* 
    Set(s1) & Set(s2) -> a in Union(s1,s2) <-> a in s1 \/ a in s2
  \end
  \eq* 
    Set(s1) & Set(s2) -> Set Union(s1,s2)
  \end

fun/2 Union 'Tex_f2_set_union'
  Union(s1,s2) = Foo

rem 
  \para \bf  Intersection.  \end \header* fun/2 Inter 'Tex_f2_set_inter' \end 
  Define the function \ft Inter(s1,s2) \end such that 
  \eq* 
    Set(s1) & Set(s2) -> a in Inter(s1,s2) <-> a in s1 & a in s2
  \end
  \eq* 
    Set(s1) & Set(s2) -> Set Inter(s1,s2)
  \end

fun/2 Inter 'Tex_f2_set_inter'
  Inter(s1,s2) = Foo

rem 
  \para \bf  Difference.  \end \header* fun/2 Diff 'Tex_f2_set_diff' \end Define 
  the function \ft Diff(s1,s2) \end such that 
  \eq* 
    Set(s1) & Set(s2) -> a in Diff(s1,s2) <-> a in s1 & a !in s2
  \end
  \eq* 
    Set(s1) & Set(s2) -> Set Diff(s1,s2)
  \end

fun/2 Diff 'Tex_f2_set_diff'
  Diff(s1,s2) = Foo

rem 
  \para \bf  Symmetric difference.  \end 
  \header* fun/2 Sdiff 'Tex_f2_set_sdiff' \end Define the function 
  \ft Sdiff(s1,s2) \end such that 
  \eq* 
    Set(s1) & Set(s2) -> a in Sdiff(s1,s2) <-> 
    a in s1 & a !in s2 \/ a !in s1 & a in s2
  \end
  \eq* 
    Set(s1) & Set(s2) -> Set Sdiff(s1,s2)
  \end

fun/2 Sdiff 'Tex_f2_set_sdiff'
  Sdiff(s1,s2) = Foo

rem 
  \para \bf  Set equality.  \end \header* pred/2 Eqset 'Tex_p2_set_eqset' \end 
  Define the predicate \ft Eqset(s1,s2) \end such that 
  \eq* 
    Set(s1) & Set(s2) -> Eqset(s1,s2) <-> \a a(a in s1 <-> a in s2)
  \end

pred/2 Eqset 'Tex_p2_set_eqset'
  Eqset(s1,s2) <-> Poo

rem 
  \para \bf  Subsets.  \end \header* pred/2 Subset 'Tex_p2_set_subset' \end 
  Define the predicate \ft Subset(s1,s2) \end such that 
  \eq* 
    Set(s1) & Set(s2) -> Subset(s1,s2) <-> \a a(a in s1 -> a in s2)
  \end

pred/2 Subset 'Tex_p2_set_subset'
  Subset(s1,s2) <-> Poo

